package it.gulch.ld2012.network2;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;

import org.apache.http.util.ByteArrayBuffer;

import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.Toast;

public class DownloadTask extends AsyncTask<Void, Void, String>
{
	private static final String TAG = DownloadTask.class.getSimpleName();

	private static final String ADDRESS = "http://search.twitter.com/search.rss?q=gulchLUG";

	private Context context;

	public DownloadTask(Context context)
	{
		this.context = context;
	}

	// esegue codice in background
	// si dovrebbero eseguire qui tutte le operazioni lunghe e dispendiose per
	// le risorse di sistema (cpu, ram), non solo il download
	@Override
	protected String doInBackground(Void... params)
	{
		byte[] downloadedXml;
		try {
			downloadedXml = doDownload();
		} catch(IOException e) {
			return null;
		}

		return new String(downloadedXml);
	}

	// eseguita prima della doInBackground, nel thread della UI
	@Override
	protected void onPreExecute()
	{
		super.onPreExecute();
	}

	// eseguita dopo della doInBackground, nel thread della UI
	@Override
	protected void onPostExecute(String result)
	{
		super.onPostExecute(result);

		if(result == null) {
			Toast.makeText(context, "È avvenuto un errore", Toast.LENGTH_LONG).show();
			return;
		}

		Log.v(TAG, result);
		// facciamo qualcosa con il risultato
	}

	private byte[] doDownload() throws IOException
	{
		URL url = new URL(ADDRESS);

		// Apro la connessione
		URLConnection ucon = url.openConnection();

		// Prendo l'inputstream della connessione
		InputStream is = ucon.getInputStream();
		BufferedInputStream bis = new BufferedInputStream(is);

		// Scrivo nel buffer finché c'è qualcosa da leggere
		ByteArrayBuffer baf = new ByteArrayBuffer(50);
		int current = 0;
		while((current = bis.read()) != -1) {
			baf.append((byte) current);
		}

		// converto il buffer in un byte[]
		return baf.toByteArray();
	}
}