package it.gulch.ld2012.network2;

import android.app.Activity;
import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class MainActivity extends Activity
{
	private Button loadTweets;

	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		loadTweets = (Button) findViewById(R.id.loadTweets);
		loadTweets.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v)
			{
				if(!isConnected()) {
					Toast.makeText(MainActivity.this, "Attenzione! Non sei connesso!", Toast.LENGTH_LONG).show();
					return;
				}

				// Istanzio la classe DownloadTask (fa parte del progetto)
				DownloadTask downloadTask = new DownloadTask(MainActivity.this);
				// la mando in esecuzione
				downloadTask.execute();
			}
		});
	}

	protected boolean isConnected()
	{
		// Recupero il ConnectivityManager di sistema
		ConnectivityManager connectivityManager = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		// Ottengo le informazioni sulla rete attualmente attiva
		NetworkInfo networkInfo = connectivityManager.getActiveNetworkInfo();

		// verifico di essere connesso
		return(networkInfo != null && networkInfo.isConnected());
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu)
	{
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}
}
