package it.gulch.ld2012.network3;

import java.io.BufferedInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;

import android.content.Context;
import android.os.AsyncTask;
import android.widget.Toast;

public class DownloadTask extends AsyncTask<String, Void, Boolean>
{
	private Context context;

	public DownloadTask(Context context)
	{
		this.context = context;
	}

	@Override
	protected Boolean doInBackground(String... params)
	{
		try {
			downloadFile(params[0], params[1]);
		} catch(IOException e) {
			return false;
		}

		return true;
	}

	@Override
	protected void onPostExecute(Boolean result)
	{
		super.onPostExecute(result);

		if(result == false) {
			Toast.makeText(context, "È avvenuto un errore", Toast.LENGTH_LONG).show();
			return;
		}

		Toast.makeText(context, "File scaricato!", Toast.LENGTH_LONG).show();
	}

	private void downloadFile(String address, String filename) throws IOException
	{
		URL url = new URL(address);

		URLConnection ucon = url.openConnection();

		BufferedInputStream bis = new BufferedInputStream(ucon.getInputStream());

		FileOutputStream output = new FileOutputStream(filename);

		byte data[] = new byte[1024];
		int count;
		while((count = bis.read(data)) != -1) {
			output.write(data, 0, count);
		}

		output.flush();
		output.close();
		bis.close();
	}
}
