package it.gulch.ld2012.network3;

import android.app.Activity;
import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class MainActivity extends Activity
{
	private Button loadBigFile;

	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		loadBigFile = (Button) findViewById(R.id.button1);
		loadBigFile.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v)
			{
				if(!isConnected()) {
					Toast.makeText(MainActivity.this, "Attenzione! Non sei connesso!", Toast.LENGTH_LONG).show();
					return;
				}

				if(!isConnectedToWifi()) {
					Toast.makeText(MainActivity.this, "Attenzione! Non sei connesso in wifi!", Toast.LENGTH_LONG)
							.show();
					return;
				}

				DownloadTask downloadTask = new DownloadTask(MainActivity.this);
				downloadTask.execute("http://dl.google.com/android/android-sdk_r20.0.3-linux.tgz", "/sdcard/file.tgz");
			}
		});
	}

	private boolean isConnectedToWifi()
	{
		ConnectivityManager connectivityManager = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);

		// Ottengo dal connectivityManager le informazioni sulla rete WiFi
		NetworkInfo networkInfo = connectivityManager.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
		boolean isWifiConnected = networkInfo.isConnected();

		return isWifiConnected;
	}

	private boolean isConnected()
	{
		ConnectivityManager connectivityManager = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo networkInfo = connectivityManager.getActiveNetworkInfo();

		return(networkInfo != null && networkInfo.isConnected());
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu)
	{
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}
}
